package com.example.controlbrazorobotico.Activities;

import android.annotation.TargetApi;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;

import com.example.controlbrazorobotico.Bluetooth.ConectionBT;
import com.example.controlbrazorobotico.Bluetooth.DeviceListActivity;
import com.example.controlbrazorobotico.util.FileDialog;
import com.example.controlbrazorobotico.R;
import com.example.controlbrazorobotico.util.Robot;
import com.example.controlbrazorobotico.util.Utilidades;

public class ControlPaleta extends Activity
{
    private String ruta = "", address, ordenesExistentes, ordenFinal;
    private ArrayList<String> ordenActual;
    private ConectionBT conexion;
    private ArrayAdapter[] adapters;
    private ListView Listados[];
    private ArrayList<String> listas[];
    private int modo, posicion;
    private Button botonSTOP;

    @TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_control_paleta);

        //Log.v("DEBUG", "Modo Paleta => Iniciamos configuración");

        if (BluetoothAdapter.getDefaultAdapter() == null)
        {
            Error("Este dispositivo no dispone de conexión Bluetooth");
            finish();
            return;
        }

        if (!BluetoothAdapter.getDefaultAdapter().isEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, 1);
        }
        //Log.v("DEBUG", "Modo Paleta => Obtenemos elementos");
        Intent serverIntent = new Intent(this, DeviceListActivity.class);
        startActivityForResult(serverIntent, 2);
        //Log.v("DEBUG", "Modo Paleta => Definimos los elementos");

        botonSTOP = (Button) findViewById(R.id.buttonSTOP);
        botonSTOP.setOnClickListener(new View.OnClickListener()
        {
            public void onClick(View arg0)
            {
                if(!ruta.equals(""))
                {
                    conexion.sendInstructions(new Robot(ruta).ComandosBasicos.get(14).split(","), new Robot(ruta).ComandosBasicos.get(14).split(",").length, new Robot(ruta).codigoCorrecto);
                    ordenFinal = "";
                    ordenActual.clear();
       
                }
            }
        });

        final Button botonParaProgr = (Button) findViewById(R.id.buttonPararProg);
        botonParaProgr.setOnClickListener(new View.OnClickListener()
        {
            public void onClick(View arg0)
            {
                if(!ruta.equals("")&&(!new Robot(ruta).ComandosBasicos.get(16).equals("-")))
                {
                    conexion.sendInstructions(new Robot(ruta).ComandosBasicos.get(16).split(","), new Robot(ruta).ComandosBasicos.get(16).split(",").length, new Robot(ruta).codigoCorrecto);
                    ordenFinal = "";
                    ordenActual.clear();
       
                }
            }
        });

        botonParaProgr.setEnabled(false);

        Listados = new ListView[5];
        Listados[0] = (ListView) findViewById(R.id.PaletaList1);
        Listados[1] = (ListView) findViewById(R.id.PaletaList2);
        Listados[2] = (ListView) findViewById(R.id.PaletaList3);
        Listados[3] = (ListView) findViewById(R.id.PaletaList4);
        Listados[4] = (ListView) findViewById(R.id.PaletaList5);

        listas = new ArrayList[7];
        for(int i=0; i<7; i++)
            listas[i] = new ArrayList<String>();
        adapters = new ArrayAdapter[5];
        
        listas[0] = new ArrayList<String>();
        adapters[0] = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listas[0]);
        Listados[0].setAdapter(adapters[0]);

        listas[1] = new ArrayList<String>();
        adapters[1] = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listas[1]);
        Listados[1].setAdapter(adapters[1]);

        listas[2] = new ArrayList<String>();
        adapters[2] = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listas[2]);
        Listados[2].setAdapter(adapters[2]);

        listas[3] = new ArrayList<String>();
        adapters[3] = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listas[3]);
        Listados[3].setAdapter(adapters[3]);

        listas[4] = new ArrayList<String>();
        adapters[4] = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listas[4]);
        Listados[4].setAdapter(adapters[4]);

        listas[5] = new ArrayList<String>();

        ordenActual = new ArrayList<String>();
        ordenActual.add("");

        Listados[0].setOnItemClickListener(new AdapterView.OnItemClickListener()
        {
            @Override
            public void onItemClick(AdapterView<?> av, View v, int pos, long id)
            {
                listas[1].clear();
                adapters[1].clear();
                adapters[2].clear();
                adapters[3].clear();
                adapters[4].clear();
                Robot robot = new Robot(ruta);
                ordenesExistentes = "";
                ordenFinal = "";
                ordenActual.clear();
   
                switch(pos)
                {
                    case 0: // Movimiento
                        if(!robot.ComandosBasicos.get(2).equals("-"))
                        {
                            listas[1].add("Activar Motor");
                            ordenesExistentes += "00";
                        }
                        if(!robot.ComandosBasicos.get(3).equals("-"))
                        {
                            listas[1].add("Definir Movimiento del Motor");
                            ordenesExistentes += "01";
                        }
                        if(!robot.ComandosBasicos.get(4).equals("-")&&!robot.ComandosBasicos.get(5).equals("-"))
                        {
                            listas[1].add("Abrir Pinza");
                            ordenesExistentes += "02";
                            listas[1].add("Cerrar Pinza");
                            ordenesExistentes += "03";
                        }
                        if(!robot.ComandosBasicos.get(8).equals("-")&&!robot.ComandosBasicos.get(9).equals("-"))
                        {
                            listas[1].add("Crear Etiqueta");
                            ordenesExistentes += "04";
                            listas[1].add("Ir a Etiqueta");
                            ordenesExistentes += "05";
                        }
                        if(!robot.ComandosBasicos.get(10).equals("-")&&!robot.ComandosBasicos.get(11).equals("-"))
                        {
                            listas[1].add("Leer Entrada");
                            ordenesExistentes += "06";
                            listas[1].add("Escribir Salida");
                            ordenesExistentes += "07";
                        }
                        if(!robot.ComandosBasicos.get(0).equals("-"))
                        {
                            listas[1].add("Ir a Hard Home");
                            ordenesExistentes += "08";
                            if(!robot.ComandosBasicos.get(12).equals("-"))
                            {
                                listas[1].add("Definir Soft Home");
                                ordenesExistentes += "09";
                            }
                            if(!robot.ComandosBasicos.get(13).equals("-"))
                            {
                                listas[1].add("Ir a Soft Home");
                                ordenesExistentes += "10";
                            }
                        }
                        modo = 0;
                        Log.d("DEBUG", "Pulsado Modo Mover");
                        break;
                    case 1: // Programa
                        if(!robot.ComandosBasicos.get(6).equals("-"))
                        {
                            listas[1].add("Recibir programa");
                            ordenesExistentes += "0";
                        }
                        if(!robot.ComandosBasicos.get(7).equals("-"))
                        {
                            listas[1].add("Enviar Programa");
                            ordenesExistentes += "1";
                        }
                        if(!robot.ComandosBasicos.get(15).equals("-"))
                        {
                            listas[1].add("Ejecutar Programa");
                            ordenesExistentes += "2";
                        }
                        modo = 1;
                        Log.d("DEBUG", "Pulsado Modo Programa");
                        break;
                }
                adapters[1].notifyDataSetChanged();
            }
        });

        Listados[1].setOnItemClickListener(new AdapterView.OnItemClickListener()
        {
            @Override
            public void onItemClick(AdapterView<?> av, View v, int pos, long id)
            {
                listas[2].clear();
                adapters[2].clear();
                adapters[3].clear();
                adapters[4].clear();
                Robot robot = new Robot(ruta);
                ordenActual.clear();
   
                posicion = 0;
                switch(modo)
                {
                    case 0: // Modo Movimiento
                        OrdenesAIncluir(Integer.parseInt("" + ordenesExistentes.charAt(pos*2) + ordenesExistentes.charAt(pos*2+1)), robot);
                        break;
                    case 1: // Modo Programa
                        Log.d("DEBUG", "Pulsado una orden del Modo Programa: " + pos + " en " + ordenesExistentes.substring(1,2));
                        switch(pos)
                        {
                            case 0: // O Recibir o Enviar o Ejecutar
                                if(ordenesExistentes.substring(0,1).equals("0")) // Recibir
                                {
                                    Log.d("DEBUG", "Pulsado Recibir");
                                    botonParaProgr.setEnabled(false);
                                    ordenFinal = "";
                                    ordenActual.clear();

                                    listas[6].clear();
                                    conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","),robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                                    listas[6] = conexion.ObtenInstrucciones(robot.ComandosBasicos.get(6), robot.codigoCorrecto);
                                    if(listas[6].size()>0)
                                    {
                                        Intent intent = new Intent(ControlPaleta.this, FileDialog.class);
                                        //Log.v("DEBUG", "Modo Paleta => Llamamos a File Dialog");
                                        startActivityForResult(intent, 4);
                                    }
                                    else
                                        Error("No hay ningún programa para cargar");
                                    break;
                                }
                                else
                                {
                                    if(ordenesExistentes.substring(0,1).equals("1"))
                                    {
                                        Log.d("DEBUG", "Pulsado Enviar");
                                        botonParaProgr.setEnabled(false);
                                        adapters[1].clear();
                                        adapters[2].clear();
                                        ordenFinal = "";
                                        ordenActual.clear();
                           
                                        listas[5].clear();
                                        Intent intent = new Intent(ControlPaleta.this, FileDialog.class);
                                        //Log.v("DEBUG", "Modo Paleta => Llamamos a File Dialog");
                                        startActivityForResult(intent, 5);
                                        break;
                                    }
                                    else
                                    {
                                        Log.d("DEBUG", "Pulsado Ejecutar");
                                        conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","),robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                                        conexion.sendInstructions(robot.ComandosBasicos.get(15).split(","), robot.ComandosBasicos.get(15).split(",").length, robot.codigoCorrecto);
                                        adapters[1].clear();
                                        adapters[2].clear();
                                        ordenFinal = "";
                                        ordenActual.clear();
                           
                                        listas[5].clear();
                                        botonParaProgr.setEnabled(true);
                                    }
                                }
                            case 1: //  Enviar o Ejecutar
                                if(ordenesExistentes.substring(1,2).equals("1"))
                                {
                                    Log.d("DEBUG", "Pulsado Enviar");
                                    botonParaProgr.setEnabled(false);
                                    adapters[1].clear();
                                    adapters[2].clear();
                                    ordenFinal = "";
                                    ordenActual.clear();
                       
                                    listas[5].clear();
                                    Intent intent = new Intent(ControlPaleta.this, FileDialog.class);
                                    Log.v("DEBUG", "Modo Paleta => Llamamos a File Dialog");
                                    startActivityForResult(intent, 5);
                                    break;
                                }
                            case 2: // Ejecutar
                                Log.d("DEBUG", "Pulsado Ejecutar");
                                conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","),robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                                conexion.sendInstructions(robot.ComandosBasicos.get(15).split(","), robot.ComandosBasicos.get(15).split(",").length, robot.codigoCorrecto);
                                adapters[1].clear();
                                adapters[2].clear();
                                ordenFinal = "";
                                ordenActual.clear();
                                listas[5].clear();
                                botonParaProgr.setEnabled(true);
                        }
                        break;
                }
                adapters[2].notifyDataSetChanged();
            }
        });

        Listados[2].setOnItemClickListener(new AdapterView.OnItemClickListener()
        {
            @Override
            public void onItemClick(AdapterView<?> av, View v, int pos, long id)
            {
                listas[3].clear();
                adapters[3].clear();
                adapters[4].clear();
                Robot robot = new Robot(ruta);
                if(posicion>=1)
                {
                    for(int i=1; i<=posicion; i++)
                        ordenActual.remove(i);
                }
                posicion = 1;
                if(robot.NumeroParametros(ordenActual.get(0))>1)
                {
                    ordenActual.add(listas[2].get(pos));
                    listas[3].addAll((new Utilidades()).ParametrosaIncluir(ordenActual.get(0), 1, robot, 0));
                    Listados[3].setSelection(listas[3].size() / 2);
                    adapters[3].notifyDataSetChanged();
                }
                else
                {
                    botonParaProgr.setEnabled(false);
                    for(String orden : ordenActual)
                        ordenFinal += orden + ",";
                    conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","), robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                    listas[5].add(ordenFinal + listas[2].get(pos));
                    conexion.sendInstructions(listas[5].toArray(new String[listas[5].size()]), listas[5].size(), robot.codigoCorrecto);
                    adapters[2].clear();
                    adapters[3].clear();
                    ordenFinal = "";
                    ordenActual.clear();
                    listas[5].clear();
                    posicion = 0;
                }
            }
        });

        Listados[3].setOnItemClickListener(new AdapterView.OnItemClickListener()
        {
            @Override
            public void onItemClick(AdapterView<?> av, View v, int pos, long id)
            {
                listas[4].clear();
                adapters[4].clear();
                Robot robot = new Robot(ruta);
                if(posicion>=2)
                {
                    for(int i=2; i<=posicion; i++)
                        ordenActual.remove(i);
                }
                posicion = 2;
                if(robot.NumeroParametros(ordenActual.get(0))>2)
                {
                    ordenActual.add(listas[2].get(pos));
                    listas[4].addAll((new Utilidades()).ParametrosaIncluir(ordenActual.get(0), 2, robot, 0));
                    Listados[4].setSelection(listas[4].size()/2);
                    adapters[4].notifyDataSetChanged();
                }
                else
                {
                    botonParaProgr.setEnabled(false);
                    for(String orden : ordenActual)
                    {
                        ordenFinal += orden + ",";
                        //Log.d("DEBUG", ordenFinal);
                    }
                    conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","),robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                    listas[5].add(ordenFinal + listas[3].get(pos));
                    conexion.sendInstructions(listas[5].toArray(new String[listas[5].size()]), listas[5].size(), robot.codigoCorrecto);
                    adapters[2].clear();
                    adapters[3].clear();
                    adapters[4].clear();
                    ordenFinal = "";
                    ordenActual.clear();
                    listas[5].clear();
                    posicion = 0;
                }
            }
        });

        Listados[4].setOnItemClickListener(new AdapterView.OnItemClickListener()
        {
            @Override
            public void onItemClick(AdapterView<?> av, View v, int pos, long id)
            {
                Robot robot = new Robot(ruta);
                botonParaProgr.setEnabled(false);
                for(String orden : ordenActual)
                    ordenFinal += orden + ",";
                conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","),robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                listas[5].add(ordenFinal + listas[4].get(pos));
                conexion.sendInstructions((String[]) listas[5].toArray(), listas[5].size(), robot.codigoCorrecto);
                adapters[2].clear();
                adapters[3].clear();
                adapters[4].clear();
                ordenFinal = "";
                ordenActual.clear();
                listas[5].clear();
                posicion = 0;
            }
        });

        //Log.v("DEBUG", "Modo Paleta => Definimos los botones");
        //Log.v("DEBUG", "Modo Paleta => Obtenemos la ruta");
        ruta = getIntent().getStringExtra("ruta");
        if(ruta==null || ruta.length()<5)
        {
            Intent intent = new Intent(ControlPaleta.this, FileDialog.class);
            //Log.v("DEBUG", "Modo Paleta => Llamamos a File Dialog");
            startActivityForResult(intent, 0);
        }
        else
        {
            listas[0].clear();
            listas[0].add("Mover");
            listas[0].add("Programa");
            listas[0].add("Configuración");
            adapters[0].notifyDataSetChanged();
        }
    }

    private void OrdenesAIncluir(int N, Robot robot)
    {
        if(ordenActual.size()==0)
        {
            switch(N)
            {
                case 0: // Motor
                    ordenActual.add(robot.ComandosBasicos.get(2));
                    break;
                case 1: // Def Motor
                    ordenActual.add(robot.ComandosBasicos.get(3));
                    break;
                case 2: // Abrir Pinza
                    ordenActual.add(robot.ComandosBasicos.get(5));
                    break;
                case 3: // Cerrar Pinza
                    ordenActual.add(robot.ComandosBasicos.get(4));
                    break;
                case 4: // Crear Etiqueta
                    ordenActual.add(robot.ComandosBasicos.get(8));
                    break;
                case 5: // Ir a Etiqueta
                    ordenActual.add(robot.ComandosBasicos.get(9));
                    break;
                case 6: // Leer Entrada
                    ordenActual.add(robot.ComandosBasicos.get(10));
                    break;
                case 7: // Escribir Salida
                    ordenActual.add(robot.ComandosBasicos.get(11));
                    break;
                case 8: // Hard Home
                    ordenActual.add(robot.ComandosBasicos.get(1));
                    break;
                case 9: // Definir Soft Home
                    ordenActual.add(robot.ComandosBasicos.get(12));
                    break;
                case 10: // Ir a Soft Home
                    ordenActual.add(robot.ComandosBasicos.get(13));
                    break;
            }
        }
        if(ordenActual.get(0).indexOf('$')!=-1)
        {   // No es una orden, sino sintaxis del lenguaje
            ordenFinal = ordenActual.get(0).substring(ordenActual.get(0).indexOf('$')+1);
            return;
        }
        if((new Robot(ruta)).NumeroParametros(ordenActual.get(0))>=1)
        {
            listas[2].addAll((new Utilidades()).ParametrosaIncluir(ordenActual.get(0), 0, robot, 0));
            Listados[2].setSelection(listas[2].size()/2);
            //ordenFinal += ordenALanzar;
        }
        else
        {
            conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","),robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
            ordenFinal += ordenActual.get(0);
            String[] orden = {ordenFinal};
            conexion.sendInstructions(orden, 1, robot.codigoCorrecto);
            ordenActual.clear();
            ordenActual.add("");
            ordenFinal = "";
            listas[5].clear();
        }
    }

    @SuppressWarnings("ConstantConditions")
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);
        //Log.v("DEBUG", "Modo Paleta => Volvemos de la actividad");
        switch(requestCode)
        {
            case (0) :
                // Se ha Obtenido la ruta del fichero del robot
                if (resultCode == Activity.RESULT_OK)
                {
                    ruta = data.getStringExtra("ruta");
                    //Log.v("DEBUG", "Modo Paleta => Se ha obtenido la ruta del fichero del robot: " + ruta);
                    listas[0].clear();
                    listas[0].add("Mover");
                    listas[0].add("Programa");
                    adapters[0].notifyDataSetChanged();
                    if(new Robot(ruta).ComandosBasicos.get(14).equals("-"))
                    {
                        botonSTOP.setEnabled(false);
                    }
                }
                else
                    Error("No se ha recibido ninguna ruta");
                break;

            case 1:
                // Se ha activado el modo Bluetooth
                if (resultCode == Activity.RESULT_OK)
                {
                    Intent serverIntent = new Intent(this, DeviceListActivity.class);
                    startActivityForResult(serverIntent, 2);
                }
                else
                {
                    // No se ha activado el modo Bluetooth
                    Error("No se ha activado el Bluetooth");
                    finish();
                }
                break;
            case 2:
                // Se dispone de los datos de otro dispositivo para conectarnos
                if (resultCode == Activity.RESULT_OK)
                {
                    address = data.getExtras().getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
                    conexion = new ConectionBT();
                    if(!conexion.Connect(address))
                    {
                        Intent serverIntent = new Intent(this, DeviceListActivity.class);
                        startActivityForResult(serverIntent, 3);
                    }
                }
                else
                {
                    finish();
                    return;
                }
                break;
            case 3:
                conexion = new ConectionBT();
                if(!conexion.Connect(address))
                {
                    Intent serverIntent = new Intent(this, DeviceListActivity.class);
                    startActivityForResult(serverIntent, 3);
                }
                break;
            case 4:
                // Tenemos la ruta del fichero donde almacenar el programa
                if (resultCode == Activity.RESULT_OK)
                {
                    String rutaFichero = data.getStringExtra("ruta");
                    //Log.v("DEBUG", "La ruta del fichero es: "+rutaFichero);
                    File fichero = new File(rutaFichero);
                    try
                    {
                        if(!fichero.exists())
                        {
                            fichero.createNewFile();
                        }
                        else
                        {
                            PrintWriter writer = new PrintWriter(fichero);
                            writer.print("");
                            writer.close();
                        }
                        FileWriter writer = new FileWriter(fichero, true);
                        for(String orden : listas[6])
                        {
                            //Log.v("DEBUG", "Orden: "+orden);
                            writer.write(orden+(char)10);
                        }
                        writer.close();
                        listas[6].clear();
                    }
                    catch (IOException e)
                    {
                        e.printStackTrace();
                    }
                }
                break;
            case 5:
                if (resultCode == Activity.RESULT_OK)
                {
                    String rutaFichero = data.getStringExtra("ruta");
                    //Log.v("DEBUG", "La ruta del fichero es: "+rutaFichero);
                    try
                    {
                        listas[6].clear();
                        FileInputStream in = new FileInputStream(rutaFichero);
                        InputStreamReader inputStreamReader = new InputStreamReader(in);
                        BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
                        String line;
                        while ((line = bufferedReader.readLine()) != null)
                        {
                            listas[6].add(line+(char)10);
                        }
                    }
                    catch (FileNotFoundException e)
                    {
                        Error("No se ha podido encontrar el fichero");
                        break;
                    }
                    catch (IOException e)
                    {
                        Error("Error con el fichero");
                        break;
                    }
                    Robot robot = new Robot(ruta);
                    conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","), robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                    listas[5].add(new Robot(ruta).ComandosBasicos.get(7));
                    conexion.sendInstructions((new Robot(ruta).ComandosBasicos.get(7)).split(","), (new Robot(ruta).ComandosBasicos.get(7)).split(",").length, robot.codigoCorrecto);
                    conexion.EnviaPrograma(listas[6], robot.codigoCorrecto);
                    ordenFinal = "";
                    ordenActual.clear();
       
                    break;
                }
                else
                    Error("No se ha recibido ninguna ruta");
                break;
        }
    }

    @Override
    @SuppressWarnings("NullableProblems")
    public boolean onKeyDown(int keyCode, KeyEvent event)
    {
        if (keyCode == KeyEvent.KEYCODE_BACK)
        {
            conexion.Disconnect();
        }
        return super.onKeyDown(keyCode, event);
    }

    public void Error(String mensaje)
    {
        Toast.makeText(this, mensaje, Toast.LENGTH_LONG).show();
    }
}