package com.example.controlbrazorobotico.Activities;

import java.io.*;
import java.util.*;

import android.annotation.TargetApi;
import android.os.Build;
import android.os.Bundle;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.Intent;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

import com.example.controlbrazorobotico.Bluetooth.ConectionBT;
import com.example.controlbrazorobotico.Bluetooth.DeviceListActivity;
import com.example.controlbrazorobotico.util.FileDialog;
import com.example.controlbrazorobotico.R;
import com.example.controlbrazorobotico.R.id;
import com.example.controlbrazorobotico.util.Robot;

public class ControlProgramado extends Activity 
{
	private String ruta;
    private ArrayList<String> listadoInstrucciones;
    private int posInstrucSelec;
    private ArrayAdapter<String> adapter;
    private Button botonGuardar;
    private ConectionBT conexion;
    private String address;

    @TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_control_programado);
		if (BluetoothAdapter.getDefaultAdapter() == null) 
		{
            Error("Este dispositivo no dispone de conexión Bluetooth");
			finish();
			return;
		}

		if (!BluetoothAdapter.getDefaultAdapter().isEnabled()) {
			Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
			startActivityForResult(enableIntent, 4);
		}
		Intent serverIntent = new Intent(this, DeviceListActivity.class);
		startActivityForResult(serverIntent, 5);


        ListView listaInstrucciones = (ListView) findViewById(id.listaInstrucciones);
        listaInstrucciones.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> av, View v, int pos, long id) {
                //log.v("DEBUG", "Control Programado => Se ha pulsado una instrucci?n");
                posInstrucSelec = pos;
            }
        });
        listadoInstrucciones = new ArrayList<String>();
        //log.v("DEBUG", "Control Programado => Definimos el Adapter");
        adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listadoInstrucciones);
        ////log.v("DEBUG", "Control Programado => Asociamos el Adapter");
        listaInstrucciones.setAdapter(adapter);

        posInstrucSelec = -1;
		final Button botonNuevaInstruccion = (Button) findViewById(R.id.ButtonAdd);
		botonNuevaInstruccion.setOnClickListener(new OnClickListener()
		{
			public void onClick(View arg0)
			{
				Intent intent = new Intent(ControlProgramado.this, Inserta_Orden.class);
				intent.putExtra("ruta", ruta);
				startActivityForResult(intent, 1);
			}
		});

		final Button botonEditarInstruccion = (Button) findViewById(R.id.ButtonEdit);
		botonEditarInstruccion.setOnClickListener(new OnClickListener()
		{
			public void onClick(View arg0)
			{
				if(posInstrucSelec!=-1)
				{
					Intent intent = new Intent(ControlProgramado.this, Inserta_Orden.class);
					intent.putExtra("ruta", ruta);
					startActivityForResult(intent, 3);
				}
			}
		});

		Button botonEliminar = (Button) findViewById(R.id.ButtonDel);
		botonEliminar.setOnClickListener(new OnClickListener()
		{
			public void onClick(View arg0)
			{
				if(posInstrucSelec!=-1)
				{
					//log.v("DEBUG", "Control Programado => Se va a eliminar la instruccion: "+listadoInstrucciones.get(posInstrucSelec));
					listadoInstrucciones.remove(posInstrucSelec);
					adapter.notifyDataSetChanged();

					posInstrucSelec = -1;
				}
                if(listadoInstrucciones.size()==0)
                    botonGuardar.setEnabled(false);
			}
		});
		Button botonLeerFichero = (Button) findViewById(R.id.ButtonLoad);
		botonLeerFichero.setOnClickListener(new OnClickListener()
		{
			public void onClick(View arg0)
			{
				//Log.v("DEBUG", "Control Programado => Se va a leer el código de un fichero");
				Intent intent = new Intent(ControlProgramado.this, FileDialog.class);
				startActivityForResult(intent, 2);
			}
		});

		Button botonEnvio = (Button) findViewById(R.id.ButtonSend);
		botonEnvio.setOnClickListener(new OnClickListener()
		{
			public void onClick(View arg0)
			{
                Robot robot = new Robot(ruta);
                for(int i=0; i<listadoInstrucciones.size(); i++)
                {
                    listadoInstrucciones.set(i, listadoInstrucciones.get(i)+(char)10);
                }
                conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","), robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                conexion.sendInstructions((new Robot(ruta).ComandosBasicos.get(7)).split(","), (new Robot(ruta).ComandosBasicos.get(7)).split(",").length, robot.codigoCorrecto);
                conexion.EnviaPrograma(listadoInstrucciones, robot.codigoCorrecto);
			}
		});

        Button botonCarga = (Button) findViewById(id.buttonCargarPrograma);
        botonCarga.setOnClickListener(new OnClickListener()
        {
            public void onClick(View arg0)
            {
                Log.v("DEBUG", "Control Programado => Llamamos la carga del programa que hay en memoria del robot");
                Robot robot = new Robot(ruta);
                String instruccion = (new Robot(ruta).ComandosBasicos.get(6));
                listadoInstrucciones.clear();
                listadoInstrucciones.addAll( conexion.ObtenInstrucciones(instruccion, robot.codigoCorrecto));
                listadoInstrucciones.remove(0);
                listadoInstrucciones.remove(listadoInstrucciones.size()-1);
                adapter.notifyDataSetChanged();
                botonGuardar.setEnabled(true);
            }
        });

        botonGuardar = (Button) findViewById(id.buttonGuardar);
        botonGuardar.setOnClickListener(new OnClickListener()
        {
            public void onClick(View arg0)
            {
                //log.v("DEBUG", "Control Programado => Llamamos al almacenamiento del programa en memoria local");
                Intent intent = new Intent(ControlProgramado.this, FileDialog.class);
                //log.v("DEBUG", "Control Programado => Llamamos a File Dialog");
                startActivityForResult(intent, 7);
            }
        });
        botonGuardar.setEnabled(false);

		//log.v("DEBUG", "Control Programado => Iniciamos la actividad");
		////log.v("DEBUG", "Control Programado => Creamos el Intent");
		ruta = getIntent().getStringExtra("ruta");
		if(ruta.length()<5)
		{		
			Intent intent = new Intent(ControlProgramado.this, FileDialog.class);
			//log.v("DEBUG", "Control Programado => Llamamos a File Dialog");
			startActivityForResult(intent, 0);
		}
	}

	@Override 
	public void onActivityResult(int requestCode, int resultCode, Intent data) {     
		super.onActivityResult(requestCode, resultCode, data); 
		//log.v("DEBUG", "Control Programado => Volvemos de la actividad");
		switch(requestCode) { 
		case (0) : 
			// Se ha Obtenido la ruta del fichero del robot
			if (resultCode == Activity.RESULT_OK) 
			{ 
				ruta = data.getStringExtra("ruta");
				//log.v("DEBUG", "Control Programado => Se ha obtenido la ruta del fichero del robot: "+ruta);
			} 
			break; 
		case (1) : 
			// Se ha completado a insercion de la nueva instrucci?n
			if(resultCode == Activity.RESULT_OK)
			{
				listadoInstrucciones.add(data.getStringExtra("Orden"));
				//log.v("DEBUG", "Control Programado => Se ha obtenido la nueva orden: " + listadoInstrucciones.get(listadoInstrucciones.size()-1));
				adapter.notifyDataSetChanged();
                botonGuardar.setEnabled(true);
			}
			break;
		case (2) : 
			// Se ha Obtenido la ruta del fichero del robot
			if (resultCode == Activity.RESULT_OK) 
			{ 
				//log.v("DEBUG", "Control Programado => Se ha obtenido la ruta del fichero del código");
				try
				{
					InputStream file = new FileInputStream(data.getStringExtra("ruta"));
					if(file!=null)
					{
						InputStreamReader inputreader = new InputStreamReader(file);
						BufferedReader buffreader = new BufferedReader(inputreader);

						String line;
						listadoInstrucciones.clear();
						line = buffreader.readLine();
						while(line!=null)
						{
							listadoInstrucciones.add(line);
							line = buffreader.readLine();
						}
                        listadoInstrucciones.remove(0);
                        listadoInstrucciones.remove(listadoInstrucciones.size()-1);
						buffreader.close();
						adapter.notifyDataSetChanged();
                        botonGuardar.setEnabled(true);
					}
				}
				catch (IOException e) 
				{
					e.printStackTrace();
				}
			} 
			break; 
		case (3) : 
			// Se ha completado a selecci?n de la nueva instrucci?n
			if(resultCode == Activity.RESULT_OK)
			{
				//log.v("DEBUG", "Control Programado => Se ha obtenido la orden modificada");
				listadoInstrucciones.set(posInstrucSelec, data.getStringExtra("Orden"));
				adapter.notifyDataSetChanged();
				posInstrucSelec = -1;
			}
			break;
		case 4:
			// Se ha activado el modo Bluetooth
			if (resultCode == Activity.RESULT_OK) 
			{
				Intent serverIntent = new Intent(this, DeviceListActivity.class);
				startActivityForResult(serverIntent, 1);
			} 
			else 
			{
				// No se ha activado el modo Bluetooth
                Error("No se ha activado el modo Bluetooth");
				finish();
			}
		case 5:
			// Se dispone de los datos de otro dispositivo para conectarnos
			if (resultCode == Activity.RESULT_OK) 
			{
				address = data.getExtras().getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
				conexion = new ConectionBT();
                if(!conexion.Connect(address))
                {
                    Intent serverIntent = new Intent(this, DeviceListActivity.class);
                    startActivityForResult(serverIntent, 6);
                }
			}
			else
			{
				finish();
				return;
			}
			break;
        case 6:
            conexion = new ConectionBT();
            if(!conexion.Connect(address))
            {
                Intent serverIntent = new Intent(this, DeviceListActivity.class);
                startActivityForResult(serverIntent, 6);
            }
            break;
        case 7:
            if (resultCode == Activity.RESULT_OK)
            {
                String rutaFichero = data.getStringExtra("ruta");
                File fichero = new File(rutaFichero);
                try
                {
                    if(!fichero.exists())
                    {
                        fichero.createNewFile();
                    }
                    else
                    {
                        PrintWriter writer = new PrintWriter(fichero);
                        writer.print("");
                        writer.close();
                    }
                    FileWriter writer = new FileWriter(fichero, true);
                    for(String orden : listadoInstrucciones)
                    {
                        writer.write(orden);
                    }
                    writer.close();
                }
                catch (IOException e)
                {
                    e.printStackTrace();
                }
            }
            break;
		}
	}

    @Override
    @SuppressWarnings("NullableProblems")
    public boolean onKeyDown(int keyCode, KeyEvent event)
    {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0)
        {
            conexion.Disconnect();
        }
        return super.onKeyDown(keyCode, event);
    }

    public void Error(String mensaje)
    {
        Toast.makeText(this, mensaje, Toast.LENGTH_LONG).show();
    }

}
