package com.example.controlbrazorobotico.Activities;

import android.annotation.TargetApi;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
//import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import com.example.controlbrazorobotico.Bluetooth.ConectionBT;
import com.example.controlbrazorobotico.Bluetooth.DeviceListActivity;
import com.example.controlbrazorobotico.util.FileDialog;
import com.example.controlbrazorobotico.R;
import com.example.controlbrazorobotico.util.Robot;

public class EnvioDirecto extends Activity
{
    private Robot robot;
    private String rutaFichero;
    private ArrayList<String> listadoOriginal, listadoCorregidas;
    private ArrayAdapter<String> adapterOriginal, adapterCorregidas;
    private ConectionBT conexion;

    @TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_envio_directo);
        //Log.v("DEBUG", "Envio Directo => Definimos los ArrayList");
        listadoOriginal = new ArrayList<String>();
        listadoCorregidas = new ArrayList<String>();
        //Log.v("DEBUG", "Envio Directo => Definimos los ListView");
        ListView listaOrdenesOriginal = (ListView) findViewById(R.id.listViewInstruccionesOriginal);
        ListView listaordenesCorregidas = (ListView) findViewById(R.id.listViewInstruccionesCorregidas);
        //Log.v("DEBUG", "Envio Directo => Definimos los adapters");
        adapterOriginal = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listadoOriginal);
        adapterCorregidas = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listadoCorregidas);
        listaOrdenesOriginal.setAdapter(adapterOriginal);
        listaordenesCorregidas.setAdapter(adapterCorregidas);

        final Button botonExec = (Button) findViewById(R.id.buttonExecCode);
        botonExec.setOnClickListener(new OnClickListener()
        {
            public void onClick(View view)
            {
                conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","),robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                conexion.sendInstructions(robot.ComandosBasicos.get(15).split(","), robot.ComandosBasicos.get(15).split(",").length, robot.codigoCorrecto);
            }
        });
        botonExec.setEnabled(false);

        //Log.v("DEBUG", "Envio Directo => Definimos el boton de Envio");
        final Button botonSend = (Button) findViewById(R.id.buttonSendCode);
        botonSend.setOnClickListener(new OnClickListener()
        {
            public void onClick(View view)
            {
                for(int i=0; i<listadoOriginal.size(); i++)
                {
                    listadoOriginal.set(i, listadoOriginal.get(i)+(char)10);
                }
                conexion.sendInstructions(robot.ComandosBasicos.get(0).split(","), robot.ComandosBasicos.get(0).split(",").length, robot.codigoCorrecto);
                conexion.sendInstructions((robot.ComandosBasicos.get(7)).split(","), (robot.ComandosBasicos.get(7)).split(",").length, robot.codigoCorrecto);
                conexion.EnviaPrograma(listadoOriginal, robot.codigoCorrecto);
                botonExec.setEnabled(true);
            }
        });
        botonSend.setEnabled(false);
		
		
        //Log.v("DEBUG", "Envio Directo => Definimos el boton de Corregir");
        final Button botonCorregir = (Button) findViewById(R.id.buttonComprobrarSintaxis);
        botonCorregir.setOnClickListener(new OnClickListener()
										 {
            public void onClick(View view)
            {
                //Log.v("DEBUG", "Envio Directo => Pulsamos el boton de Corregir "+listadoOriginal.size());
                listadoCorregidas.clear();
                for(int i=0; i<listadoOriginal.size()-1; i++)
                    if(!InstruccionValida(listadoOriginal.get(i)))
                        listadoCorregidas.add(listadoOriginal.get(i));
                adapterCorregidas.notifyDataSetChanged();
                if(listadoCorregidas.size()==0)
				{
                    Error("Todas las instrucciones son correctas");
					botonSend.setEnabled(true);
				}
            }
        });

        if (BluetoothAdapter.getDefaultAdapter() == null)
        {
            Error("Este dispositivo no dispone de conexión Bluetooth");
            finish();
            return;
        }

        if (!BluetoothAdapter.getDefaultAdapter().isEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, 2);
        }
        Intent serverIntent = new Intent(this, DeviceListActivity.class);
        startActivityForResult(serverIntent, 3);

        //Log.v("DEBUG", "Envio Directo => Llamamos a File Dialog");
        Intent intent = new Intent(EnvioDirecto.this, FileDialog.class);
        startActivityForResult(intent, 0);
    }

    private boolean InstruccionValida(String instruccion)
    {
        //Log.v("DEBUG", "Envio Directo => Comprobamos la instrucción "+instruccion);
        String[] elementosInstruccion = instruccion.split(",");
        if(instruccion.contains(robot.CabeceraFichero))
            return true;
        if(elementosInstruccion[0].contains(robot.ComandosBasicos.get(8).substring(1)))
            elementosInstruccion[0] = elementosInstruccion[0].substring(1);
        if(robot.ComentarioOrden(elementosInstruccion[0]).equals("ERRORNOEXISTE"))
        {
            //Log.v("DEBUG", "Envio Directo => La instrucción no existe");
            return false;
        }
        for(int k=1; k<elementosInstruccion.length; k++)
        {
            String ristraminus = "abcdefghijklmnopqrstuvwxz";
            String ristramayus = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
            String[] rangos = robot.RangoParametro(elementosInstruccion[0], k-1);
            if(rangos==null)
                return false;
            if(rangos[0].equals("IRANGE"))
            {
                int[] rang;
                if(ristraminus.contains(elementosInstruccion[k - 1]))
                    rang = robot.RangoTickBrazo(ristraminus.indexOf(elementosInstruccion[k-1]));
                else
                {
                    if(ristramayus.contains(elementosInstruccion[k - 1]))
                        rang = robot.RangoTickBrazo(ristramayus.indexOf(elementosInstruccion[k-1]));
                    else
                        rang = robot.RangoTickBrazo(Integer.parseInt(elementosInstruccion[k-1]));
                }
                if((rang[0]>Integer.parseInt(elementosInstruccion[k]))||
                        (rang[1]<Integer.parseInt(elementosInstruccion[k])))
                {
                    //Log.v("DEBUG", "Envio Directo => Los rangos de la instrucción son erróneos "+rangos[0] +" " +rangos[1]);
                    return false;
                }
            }
            else
            {
                if(rangos[0].equals("ARANGE"))
                {
                    int[] rang;
                    if(ristraminus.contains(elementosInstruccion[k - 1]))
                        rang = robot.RangoAnguloBrazo(ristraminus.indexOf(elementosInstruccion[k-1]));
                    else
                    {
                        if(ristramayus.contains(elementosInstruccion[k - 1]))
                            rang = robot.RangoAnguloBrazo(ristramayus.indexOf(elementosInstruccion[k-1]));
                        else
                            rang = robot.RangoAnguloBrazo(Integer.parseInt(elementosInstruccion[k-1]));
                    }
                    if((rang[0]>Integer.parseInt(elementosInstruccion[k]))||
                            (rang[1]<Integer.parseInt(elementosInstruccion[k])))
                    {
                        //Log.v("DEBUG", "Envio Directo => Los rangos de la instrucción son erróneos "+rangos[0] +" " +rangos[1]);
                        return false;
                    }
                }
                else
                {
                    if(ristraminus.contains(rangos[0]))
                    {
                        if(ristraminus.indexOf(rangos[0])>ristraminus.indexOf(elementosInstruccion[k]) ||
                           ristraminus.indexOf(rangos[1])<ristraminus.indexOf(elementosInstruccion[k]))
                        {
                            //Log.v("DEBUG", "Envio Directo => Los rangos de la instrucción son erróneos "+rangos[0] +" " +rangos[1]);
                            return false;
                        }
                    }
                    else
                    {
                        if(ristramayus.contains(rangos[0]))
                        {
                            if(ristramayus.indexOf(rangos[0])>ristramayus.indexOf(elementosInstruccion[k]) ||
                               ristramayus.indexOf(rangos[1])<ristramayus.indexOf(elementosInstruccion[k]))
                            {
                                //Log.v("DEBUG", "Envio Directo => Los rangos de la instrucción son erróneos "+rangos[0] +" " +rangos[1]);
                                return false;
                            }
                        }
                        else
                        {
                            if((Integer.parseInt(rangos[0])>Integer.parseInt(elementosInstruccion[k]))||
                               (Integer.parseInt(rangos[1])<Integer.parseInt(elementosInstruccion[k])))
                            {
                                //Log.v("DEBUG", "Envio Directo => Los rangos de la instrucción son erróneos "+rangos[0] +" " +rangos[1]);
                                return false;
                            }
                        }
                    }
                }
            }
        }
        return true;
    }

    private void ObtenInstrucciones()
    {
        try
        {
            InputStream file = new FileInputStream(rutaFichero);
            if(file!=null)
            {
                InputStreamReader inputreader = new InputStreamReader(file);
                BufferedReader buffreader = new BufferedReader(inputreader);

                String line;
                listadoOriginal.clear();
                line = buffreader.readLine();
                while(line!=null)
                {
                    listadoOriginal.add(line);
                    line = buffreader.readLine();
                }
                buffreader.close();
                adapterOriginal.notifyDataSetChanged();
            }
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }

    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        //Log.v("DEBUG", "Envio Directo => Volvemos de la actividad");
        switch(requestCode) {
            case 0:
                // Se ha Obtenido la ruta del fichero del robot
                if (resultCode == Activity.RESULT_OK)
                {
                    robot = new Robot(data.getStringExtra("ruta"));
                    //Log.v("DEBUG", "Envio Directo => Llamamos a File Dialog");
                    Intent intent = new Intent(EnvioDirecto.this, FileDialog.class);
                    startActivityForResult(intent, 1);
                }
                break;
            case 1:
                // Se ha Obtenido la ruta del fichero del robot
                if (resultCode == Activity.RESULT_OK)
                {
                    rutaFichero = data.getStringExtra("ruta");
                    //Log.v("DEBUG", "Envio Directo => Se ha obtenido la ruta del fichero a enviar: "+rutaFichero);
                    ObtenInstrucciones();
                }
                break;
            case 2:
                // Se ha activado el modo Bluetooth
                if (resultCode == Activity.RESULT_OK)
                {
                    Intent serverIntent = new Intent(this, DeviceListActivity.class);
                    startActivityForResult(serverIntent, 1);
                }
                else
                {
                    // No se ha activado el modo Bluetooth
                    Error("No se ha activado el modo Bluetooth");
                    finish();
                }
                break;
            case 3:
                // Se dispone de los datos de otro dispositivo para conectarnos
                if (resultCode == Activity.RESULT_OK)
                {
                    String address = data.getExtras().getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
                    conexion = new ConectionBT();
                    if(!conexion.Connect(address))
                    {
                        Intent serverIntent = new Intent(this, DeviceListActivity.class);
                        startActivityForResult(serverIntent, 3);
                    }
                }
                else
                {
                    finish();
                    return;
                }
                break;
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event)
    {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0)
        {
            conexion.Disconnect();
        }
        return super.onKeyDown(keyCode, event);
    }

    public void Error(String mensaje)
    {
        Toast.makeText(this, mensaje, Toast.LENGTH_LONG).show();
    }
}