package com.example.controlbrazorobotico.Activities;

import java.util.ArrayList;
import java.util.List;
import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
//import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;

import com.example.controlbrazorobotico.R;
import com.example.controlbrazorobotico.R.id;
import com.example.controlbrazorobotico.util.Robot;
import com.example.controlbrazorobotico.util.Utilidades;

public class Inserta_Orden extends Activity {
	
	private Robot robot;
    private EditText Comentario;
    private ArrayList<String> instrucciones;
    private Button Aceptar;
    private List<String> parametros;
    private String orden;
    private boolean label;

    @TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_inserta__orden);
        label = false;
		parametros = new ArrayList<String>();
		robot = new Robot(getIntent().getStringExtra("ruta"));
		//Log.v("DEBUG", "Inserta Orden => Obtenemos la lista de Ordenes del robot");
		instrucciones = robot.ListadoOrdenes();
        //Log.v("DEBUG", "Inserta_orden -> " + instrucciones);
        ListView listaOrdenes = (ListView) findViewById(id.listaOrdenes);
		ListView listaParam1 = (ListView) findViewById(id.listaParam1);
		ListView listaParam2 = (ListView) findViewById(id.listaParam2);
		ListView listaParam3 = (ListView) findViewById(id.listaParam3);
		final List<String> ListaParametros1 = new ArrayList<String>();
		final List<String> ListaParametros2 = new ArrayList<String>();
		final List<String> ListaParametros3 = new ArrayList<String>();
		Comentario = (EditText) findViewById(id.Comentario);
		Aceptar = (Button) findViewById(id.ButtonAceptar);
		final Button Cancelar = (Button) findViewById(id.ButtonCancelar);
		Aceptar.setEnabled(false);
		//Log.v("DEBUG", "Inserta Orden => Cargamos la lista de ordenes del robot");
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, R.layout.textolistas, instrucciones);
		final ArrayAdapter<String> adapterParam1 = new ArrayAdapter<String>(this, R.layout.textolistas, ListaParametros1);
		final ArrayAdapter<String> adapterParam2 = new ArrayAdapter<String>(this, R.layout.textolistas, ListaParametros2);
		final ArrayAdapter<String> adapterParam3 = new ArrayAdapter<String>(this, R.layout.textolistas, ListaParametros3);
		listaOrdenes.setAdapter(adapter);
		listaParam1.setAdapter(adapterParam1);
		listaParam2.setAdapter(adapterParam2);
		listaParam3.setAdapter(adapterParam3);
        Button Label = (Button) findViewById(id.ButtonLabel);
        Label.setOnClickListener(new OnClickListener()
        {
            public void onClick(View arg0)
            {
                label = true;
            }
        });
		Aceptar.setOnClickListener(new OnClickListener()
		{
			public void onClick(View arg0)
			{
				//Log.v("DEBUG", "Inserta Orden => Devolvemos la orden");
				Intent intent = new Intent();
				String salida = "";
                if(label)
                {
                    salida = robot.ComandosBasicos.get(8).substring(1);
                }
                salida += orden;
                for (String parametro : parametros)
                    salida += "," + parametro;
				//Log.v("DEBUG", "	"+salida);
				intent.putExtra("Orden", salida);
				setResult(Activity.RESULT_OK, intent);
				finish();
			}
		});
		Cancelar.setOnClickListener(new OnClickListener()
		{
			public void onClick(View arg0)
			{
				//Log.v("DEBUG", "Inserta Orden => Cancelamos y volvemos");
				Intent intent = new Intent();
				setResult(Activity.RESULT_CANCELED, intent);
				finish();
			}
		});
		listaOrdenes.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> av, View v, int pos, long id) {
                //Log.v("DEBUG", "Inserta Orden => Se ha pulsado un item en la lista de ordenes");
                parametros.clear();
                ListaParametros1.clear();
                adapterParam1.clear();
                adapterParam2.clear();
                adapterParam3.clear();
                Aceptar.setEnabled(false);
                orden = instrucciones.get(pos);
                Comentario.setText(robot.ComentarioOrden(orden).substring(1));
                if (robot.NumeroParametros(orden) > 0) {
                    ListaParametros1.addAll((new Utilidades()).ParametrosaIncluir(orden, 0, robot, 0));
                    adapterParam1.notifyDataSetChanged();
                } else {
                    Aceptar.setEnabled(true);
                }
            }
        });
		listaParam1.setOnItemClickListener(new AdapterView.OnItemClickListener() {
		    @Override
		    public void onItemClick(AdapterView<?> av, View v, int pos, long id) {
				//Log.v("DEBUG", "Inserta Orden => Se ha pulsado un item en la lista de ordenes");
		    	parametros.add(ListaParametros1.get(pos));
				ListaParametros2.clear();
				ListaParametros3.clear();
				adapterParam2.clear();
				adapterParam3.clear();
				if(robot.NumeroParametros(orden)>1)
				{
                    ListaParametros2.addAll((new Utilidades()).ParametrosaIncluir(orden, 1, robot, 0));
					adapterParam3.notifyDataSetChanged();
				}
				else
				{
					Aceptar.setEnabled(true);
				}
		    }
		});
		listaParam2.setOnItemClickListener(new AdapterView.OnItemClickListener() {
		    @Override
		    public void onItemClick(AdapterView<?> av, View v, int pos, long id) {
				//Log.v("DEBUG", "Inserta Orden => Se ha pulsado un item en la lista de ordenes");
		    	parametros.add(ListaParametros2.get(pos));
				ListaParametros3.clear();
				adapterParam3.clear();
				if(robot.NumeroParametros(orden)>2)
				{
                    ListaParametros3.addAll((new Utilidades()).ParametrosaIncluir(orden, 2, robot, 0));
					adapterParam3.notifyDataSetChanged();
				}
				else
				{
					Aceptar.setEnabled(true);
				}
		    }
		});
		listaParam3.setOnItemClickListener(new AdapterView.OnItemClickListener() {
		    @Override
		    public void onItemClick(AdapterView<?> av, View v, int pos, long id) {
				//Log.v("DEBUG", "Inserta Orden => Se ha pulsado un item en la lista de ordenes");
		    	parametros.add(ListaParametros3.get(pos));
				Aceptar.setEnabled(true);
		    }
		});
	}
}
